
      subroutine plinp (fname,tmin,tmax,pmin,pmax)

      use input_output
 
c psxypl - subroutine to output x-y plot.

      implicit real (a-g,o-z),integer (h-n)
 
      character*8 tname(4)*162,vname,names,sname*10,fname*100,cname*5
 
      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
 
      common/ cst8  /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
     *      / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / basic /n4,ifont,icopt,jwidth,iop0
     *      / csta4 /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep
     *      / cst319 /iemod(k2),kmod  

      write (*,1070) 
      read (*,1000) fname

      open (n4,err=90,file=fname,status='old')

      read (n4,*,err=91) icopt
      read (n4,*) iphct, isoct, icomp
      read (n4,*) jbulk, ivol, icp, jvol, kmod
      if (icomp.ne.0) then
         read (n4,1040) (cname(i), i = 1, icomp)
         read (n4,*) (atwt(i), i = 1, icomp)
      end if 
      if (iphct.ne.0) then
         read (n4,1010) (names(i),i = 1, iphct)
         read (n4,*) ((comps(i,j), j= 1, icomp), i = 1, iphct)
         read (n4,*) (ikp(i), i = 1, iphct)
      end if
      if (isoct.ne.0) read (n4,1030) (sname(i), i = 1, isoct) 
      read (n4,1000) tname
      read (n4,*) iv,(jv(i),i=1,iv),jpt
      read (n4,*) jcont,iind,idep,c0,c1,c2,c3,c4
      read (n4,*) (vmax(i),vmin(i),i=1,iv)
      read (n4,1000) (vname(i),i=1,iv)

c for katja:

      tmin = vmin(1)
      tmax = vmax(1)
      pmin = vmin(2)
      pmax = vmax(2)

      goto 99

90    write (*,1060) fname
      stop
91    write (*,1050) fname
      stop

1000  format (a)
1010  format (10a8)
1030  format (8a10)
1040  format (20a5)
1050  format (/,'file:',/,a,/,'is not formatted correctly.',/)
1060  format (/,'No such file as: ',a,/)
1070  format (/,'Enter plot file name: ')

99    end

c-------------------------------------------------------------------
      subroutine bplinp (fname,kpoly)

      use input_output

c subroutine to read bulk composition data file for pseudosections.

      implicit real (a-g,o-z),integer (h-n)

      character*100 fname, n5name
 
      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      common/ basic /n4,ifont,icopt,jwidth,iop0
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     */ cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     */ cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     */ cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     */ cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     */ cst20 /comps(k1,k5),atwt(k5),icomp
     */ vs    /vmin(l3),vmax(l3),iv
     *      / cst319 /iemod(k2),kmod 

      n5 = n4 + 1
      ibulk = 1
c                                    open assemblage information
c                                    file = 'b' + plot file name.
      n5name = fname 
      call inblnk (n5name,'b')
      open (n5,err=90,file=n5name,status='old')

10    read (n5,*,end=20) jd, ivar(ibulk), iap(ibulk), iflu(ibulk),
     *                   (idbk(i,ibulk), i = 1, jbulk)
      read (n5,*) (vr(i,ibulk), i = 1, iv)
      read (n5,*) ((props(j,i,ibulk), j = 1, 11), i = 1, jbulk)
      read (n5,*) (ptot(j,ibulk), j = 1, 7),btot(ibulk),gtot(ibulk),
     *            (fbulk(j,ibulk), j = 1, icomp)

      if (iflu(jd).eq.1) then 
         read (n5,*) (iflug(j,ibulk), j = 1, jbulk)
         read (n5,*) (ptot1(j,ibulk), j = 1, 7),
     *        btot1(ibulk),gtot1(ibulk),(fbulk1(j,ibulk), j = 1, icomp)
      end if

      if (kmod.ne.0) then 
         read (n5,*) iemod(ibulk)
         if (iemod(ibulk).ne.0) read (n5,*) 
     *     ((props(j,i,ibulk), j= 12, 14), i = 1, jbulk)
      end if 

      ibulk = ibulk + 1
      goto 10

20    close (n5)

      ibulk = ibulk - 1
c                                    open polygon file = 'p' + plot file name.

      kpoly = ibulk 

      goto 99 

90    write (*,1000) n5name,fname
      stop

1000  format (/,'The bulk information file:',/,a,/,' corresponding to'
     *         ,' the plot file:',/,a,/,'Does not exist.',//)

99    end   

      subroutine inblnk (text,char)
c------------------------------------------------------------------- 
c inblnk - scan text to last '/' or '\' and insert char after.
 
c     text - character string 
c-------------------------------------------------------------------
 
      character text*(*), bitsy(400)*1, char*1 
 
      read (text,1000) bitsy
c                                 scan for blanks:
      ict = 0
      nchar = len(text)

      do i = nchar,1,-1
         if (bitsy(i).eq.'/'.or.bitsy(i).eq.'\') goto 10
         bitsy(i+1) = bitsy(i)
      end do 

      i = 0

10    bitsy(i+1) = char

      write (text,1000) (bitsy(i), i = 1, nchar)
 
1000  format (400a1)
      end